=== debian/changelog ===
hashcat (3.10-1) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Team upload.
  * Add gbp.conf file.

  [ Daniel Echeverry ]
  * New upstream release.
  * debian/rules
    + Support reproducible builds. (Closes: #833056)
      + Thanks to Reiner Herrmann for the patch!.
  * debian/control
    + Remove article "The" from description to fix lintian warning.
    + Add support to kFreeBSD.
  * debian/patches
    + Refresh fix_makefile.diff patch.
    + Add add_kfreebsd_support.diff patch.
      + Thanks to Steven Chamberlain for the patch.

 -- Daniel Echeverry <epsilon77@gmail.com>  Mon, 05 Sep 2016 19:35:27 -0500

hashcat (3.00-3) unstable; urgency=medium

  [ Daniel Echeverry ]
  * debian/control
    + Add Replaces field in hashcat-data.
    + Improve description of hashcat and hashcat-data.

  [ Raphaël Hertzog ]
  * Further improve the description field.

 -- Daniel Echeverry <epsilon77@gmail.com>  Tue, 12 Jul 2016 15:57:02 -0500

hashcat (3.00-2) unstable; urgency=medium

  * debian/rules
    + Fix FTBFS with dpkg-buildpackage -B (Closes: #830832)

 -- Daniel Echeverry <epsilon77@gmail.com>  Mon, 11 Jul 2016 21:08:12 -0500

hashcat (3.00-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    + Add Debian Security Tools Packaging Team as maintainer.
    + Add Vcs-* Field.
    + Add opencl-headers in B-D.
    + Add mesa-opencl-icd | opencl-icd in Depends.
  * Remove hashcat-xop.1 file.
    + Because this version doesn't have hashcat-xop binary.
  * Add new extra documentation.
  * Update hashcat-data.examples to install new examples.
  * Update hashcat-data.install to install new files.
  * debian/patches
    + Update fix_makefile.patch.
  * debian/copyright
    + Add copyright holders.
    + Use License-Grant field.
  * debian/rules
    + Now hashcat doesn't have hashcat-xop feature
    + Remove override_dh_install because isn't necessary
    + Remove override_dh_installman because isn't necessary
    + Add override_dh_fixperms to fix some lintian warning
  * Add README.Debian File
    
 -- Daniel Echeverry <epsilon77@gmail.com>  Thu, 30 Jun 2016 11:07:00 -0500

hashcat (2.00-2) unstable; urgency=medium

  * debian/control
    + Change arch field to linux-i386 and linux-amd64 because
      hashcat only works with processors that support SSE2
  * debian/rules
    + Create dir to prevent FTBFS

 -- Daniel Echeverry <epsilon77@gmail.com>  Thu, 12 May 2016 10:38:42 -0500

hashcat (2.00-1) unstable; urgency=medium

  * Initial release (Closes: #819459)

 -- Daniel Echeverry <epsilon77@gmail.com>  Tue, 19 Apr 2016 23:08:10 -0500
