=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
INSTALL := install -o root -g root -m 755

%:
	dh $@ 

override_dh_auto_build:
	dh_auto_build -- PREFIX=/usr COMPTIME=$(SOURCE_DATE_EPOCH)

override_dh_installchangelogs:
	dh_installchangelogs docs/changes.txt

override_dh_fixperms-indep:
	dh_fixperms
	chmod 644 debian/hashcat-data/usr/share/doc/hashcat-data/examples/example0.sh
	chmod 644 debian/hashcat-data/usr/share/doc/hashcat-data/examples/example400.sh
	chmod 644 debian/hashcat-data/usr/share/doc/hashcat-data/examples/example500.sh
