=== debian/changelog ===
hashcat (3.20-1) unstable; urgency=medium

  * New upstream release.
  * Bump DH level to 10.
  * debian/patches:
    + Refresh all patches files.

 -- Daniel Echeverry <epsilon77@gmail.com>  Tue, 27 Dec 2016 23:12:20 -0500
